<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Data Structures</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Data Structures</h1>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Data Structures Overview</h2>
						<ul>
							<li><b>List Pointer Structures</b></li>
                            <li><b>Linked Lists</b></li>
                            <li><b>Stacks</b></li>
                            <li><b>Queues</b></li>
                            <li><b>Trees</b></li>
						</ul>
                    </section>
					<section>
					    <h2>Objectives</h2>
					    <a href="../objectives.html" target="_blank">Data Structures Objectives</a>
					</section>
				</section>

				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Lists and Pointer Structures</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Arrays and Pointers in Python</h3>
						<ul>
							<li>Python Lists are actually C Arrays</li>
							<li>Python DOES use pointers in the background</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
								<H2>Arrays vs Lists</H2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>C Array Advantages</h3>
						<ul>
							<li>Quick - because data is stored in memory sequentially</li>
							<li>Items can also be accessed individually</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>C Array Disadvantages</h3>
						<ul>
							<li>Array elements must all be of the same data type.</li>
							<li>If the arrays are large, then large sequences of memory must be used 
								and large sequential memory addresses may not be available.</li>
							<li>C arrays have a fixed size and cannot grow and shrink dynamically as needed.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Python List Advantages</h3>
						<ul>
							<li>List items do not need to be all of the same data type</li>
							<li>Items can be accessed individually.</li>
							<li>Can grow and shrink dynamically</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Python List Disadvantages</h3>
						<ul>
							<li>When changes are made, a new array is made from a copy of the original array
								which allows the lists to be dynamic, but sequential memory again must be used</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Disadvantages of both</h3>
						<ul>
							<li>Removing or adding data requires movement of the items in memory. This can be time consuming.</li>
						</ul>
					</section>
		
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Pointers</h4>
						<ul>
							<li>Pointers are variables that hold the memory address of another variable.</li>
							<li>Everything in python is an object</li>
							<li>Objects have memory addresses</li>
							<li>Pointers allow the passing of an object's address between functions</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h2>Pointers and Data structures</h2>
					</section>
					<section>
						<h3>Problem</h3>
						<ul>
						<li>Python doesn't use pointers at the user level</li>
						<li>Pointers can be handy when working with data that can't be put into sequential order in memory due to limited space</li>
					</ul>
					</section>
					<section>
						<h3>Solution</h3>
						<ul>
						<li>Create pointer like structures</li>
					</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Pointer Structures / Linked Lists</h3>
						<ul>
							<li>Singly Linked Lists</li>
							<li>Circularly Linked Lists</li>
							<li>Doubly Linked Lists</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Two classes create the linked list</h3>
						<ul>
							<li>Node class</li>
							<li>Linked Lists class</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Nodes</h3>
						<ul>
							<li>Linked lists use the concept of nodes</li>
							<li>Nodes are the building blocks of linked lists</li>
							<li>Nodes are built from a Node class</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Since Classes create objects, we can reuse the class to create a new object for each node of our list and connect the data with the address to the next node.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Basic Node Class has two parts</h3>
						<ul>
							<p><b><i>Data</i></b>: Contains the data element (<b>data</b>)</p>
							<p><b><i>Address</i></b>: Points to location of the next node (<b>next</b>)</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Basic Node Diagram:
						</h3>
						<img src="../Assets/linklist.png" alt="Linked List">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>
								<b>Note</b>: The last node 1 points to None. Even though these nodes are drawn contiguous to each other, in reality, they may or may not be in contiguous memory locations.
							</p>
							<p>We will discuss what the head is soon</p>
							<p>
								<b>Tip</b>: Always try to draw these data structures to get a clear understanding.
							</p>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Creating a Singly Linked List</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Node class:</h3>
                        <pre>
<code data-trim data-noescape>
#This class will represent a single linked list node
class Node:
    def __init__(self, data, next = None):
        #instantiate a Node with a default next of none
        self.data = data
        self.next = next
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						
						<ul>
							<p>The <b>Next</b> attribute points to the address of the next data in the list and allows the memory to be non-sequential.</p>
							<p>The default of next will be none so the last item in the list will point to <b>None</b>.</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>Creation of the linked list is done with the assistance of another class </p>
							<p>The <b>Linked List class</b> in combination with the <b>Node class</b>  allows the linked list to be created</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Linked List class:</h3>
                        <pre>
<code>
#This class represents the linked list
class LinkedList:
    def __init__(self):
        self.head = None 
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Linked List Class break down</h3>
						<ul>
							<li>The first item in the list is kept tracked of by a <b>head</b> pointer (self.head).</li>
							<li>The last node is sometimes referred to as the tail node or null link.</li>
							<li>This class only has one attribute of <b>head</b> (<b><i>Note</i></b>: <i>this can change</i>)</li>
							<li>The default is set to <b>none</b>, meaning the list is empty</li>
							<li>Nodes in between the head and last node do not have a name and are referenced by the link of the preceding node</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>Once the attributes are set we can add different functions for the classes to perform</p>
							<p>For now we will add new nodes to the beginning of list and we will point the head at the newly added node.</p>
							<p>If we would want to insert a node at the end of the list then we could want to keep track of the end of the list with another pointer.</p>
						</ul>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Linked List Advantages
						</h3>
						<ul>
							<li>Dynamic:  Insertion and deletion are simpler because the pointers can be updated 
								instead of the elements being shuffled in memory</li>
							<li>Stack and Queue structures can be easily implemented with lists</li>
							<li>Linked lists require smaller memory allocations than arrays or lists.  
								They do not require the memory addresses to be sequential because they 
								mimic pointers by connecting the memory addresses.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Linked List Disadvantages
						</h3>
						<ul>
							<li>Additional memory is used up by next pointers</li>
							<li>Random access is not possible.  The whole list must be traversed from the beginning 
								to get to a particular node.  This is not always the most efficient in terms of big O</li>
							<li>Each node is going to take up the space of the data type being stored as well 
								as additional space for the pointer to the next node.</li>
							<li>Can only be traversed in one direction (<b><i>This has exceptions, will cover in demos</i></b>)</li>
						</ul>
					</section>
                    <section>
                        <h2>Singly Linked List Demos</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6B_Singly_Linked_List.html">Lab 6B - Singly Linked List</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Circularly Linked List</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>A special case of a singly linked list.
						</h3>
						<img src="../Assets/circular_linked_list.png" alt="Circularly Linked List">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Circularly Linked List basics</h4>
						<ul>
							<li>Insertion and removal of the first node are special cases because the head pointer must be reset.</li>
							<li>A circularly linked list can be used with a dummy header node.</li>
							<li>The dummy contains a link from the last node back to the first node in the structure.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Classes for creating a circularly linked list</h4>
						<ul>
							<li>
								<b>Node class</b>: Will look like our original Node class for the singly linked list
							</li>
							<li><b>Circularly Linked List class</b>: Will look like our original class for the singly linked list</li>
							<p></p>
							<p>The difference will be in how the code is implemented in our functions.  New links for the head will be created before the head is set to the new node's next</p>
						</ul>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Circularly Linked List Demos</h2>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Doubly Linked List</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Doubly Linked List is a variation of the linked list. 
							It overcomes the limitation of the singly linked list only being traversed in one direction by adding an additional pointer that points to the previous node.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Nodes of a doubly linked list</h4>
						<ul>
							<li><b>Data</b> - Represents the data value stored in the node.</li>
							<li><b>Previous</b> - Represents a pointer that points to the previous node.</li>
							<li><b>Next</b> - Represents a pointer that points to the next node.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/null.png" alt="Null Link">
							<ul>
								<p>Node 1 represents the head of the list.</p>
								<p>The previous pointer of the head node will always point to NULL.</p> 
								<p>Next pointer of node one will point to node 2.</p> 
								<p>Node 5 represents the tail of the list whose previous pointer will point to node 4, and the next will point to NULL.</p>
							</ul> 
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Doubly Linked Node Class</p>
                        <pre>
<code>
class DoubleNode:
    def __init__(self, data, next = None, prev = None):
        self.data = data
        self.next = next
        self.prev = prev   
</code>
                        </pre>
						<img src="../Assets/doubly_node_class.png" alt="Double Node Class">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Doubly Linked List Class</p>
                        <pre>
<code>
class DoublyLinkedList:
    def __init__(self):
        self.head = None
        self.tail = None
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							The doubly linked list class has two nodes that initially point to null: 
						</p>
						<ul>
							<li><b>head</b> - represents the first node</li>
							<li><b>tail</b> - represents the last node</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Doubly Linked List Demos</p>
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6C_Doubly_and_Circularly_Linked_List.html">Lab 6C - Doubly Linked List</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Stacks</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							A stack is a data structure that is often likened to a stack of plates. 
							The last plate added to the top of the stack is the first plate removed from the stack. 
							A stack is a last in, first out (LIFO) structure:
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/plates.png" alt="Stack">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							There are two primary operations that are done on stacks:  
						</p>
						<ul>
							<li>push - An element is added to the top of the stack</li>
							<li>pop - An element is taken off the top of the stack</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Another operation which is sometimes used is peek, which makes it possible to see the element on the stack without popping it off
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							One very common usage for stacks is to keep track of the return address during function calls.
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code data-trim data-noescape>
def b():
    print('b')
    
def a():
    b()
    
a()
print('done')
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>When the program execution gets to the call <b>a()</b>, it first pushes the address of the following instruction <b>print("done")</b> onto the stack, then jumps to <b>a</b>.</p>
							<p>Inside <b>a</b>, <b>b()</b>  is called, but before that, the return address of <b>a</b> is pushed onto the stack.</p>
							<p>Once in <b>b()</b> the function is done, the return address is popped off the stack, which takes us back to <b>a()</b>.</p>
							<p>When <b>a</b> has completed, the return address is popped off the stack, which takes us back to the <b>print('done')</b> statement.</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Stacks are also used to pass data between functions:
						</h3>
						<pre>
<code data-trim data-noescape>
#function call
somefunc(42, 'hash browns', 'spam','ham')
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							What will happen is that 42, 'hash browns', 'spam' and 'ham' will be pushed onto the stack, one at a time:
						</p>
						<img src="../Assets/Node0.png" alt="Node0">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							When the code jumps into the function, the values for a, b, c, d will be popped off the stack. The ham element will be popped off first and assigned to d, then "spam" will be assigned to c, and so on:
						</p>
						<pre>
<code data-trim data-noescape>
def somefunc(a, b, c, d):
    print("function executed")
</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Stack Implementation</h3>
						<ul>
							<li>Node Class</li>
							<li>Stack Class</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Node class:
						</h3>
						<pre>
<code data-trim data-noescape>
class Node:
    def __init__(self, data = None):
        self.data = data
        self.next = None
</code>
						</pre>
                        <p>The node class implements a stack instead of a list, but the same principle of nodes linked together still applies.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Stack class:</h3>
						<pre>
<code data-trim data-noescape>
class Stack:
    def __init__(self):
        self.top = None
        self.size = 0
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Push operation</h3>
                        <pre>
<code data-trim data-noescape>
def push(self, data):
    node = Node(data)
    if self.top:
        node.next = self.top
        self.top = node
    else:
        self.top = node
        self.size += 1
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							In a scenario where we have an existing stack, we move self.top so that it points to the newly created node.
							The newly created node must have its next pointer, pointing to the node that used to be the top node on the stack. This is the first condition of the if statemen
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/Node2.png" alt="Node2">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							The else condition covers the situation where there is no existing node after creating our new node, meaning the stack was initially empty, self.top will point to this new node:
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/Node.png" alt="Node">
					</section>
					
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Pop operation</h3>
						<p>
							Now we need a pop method to remove the top element from the stack. As we do so, we need to return the topmost element as well. We will make the stack return None if there are no more elements:
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code data-trim data-noescape>
def pop(self):
    if self.top:
        data = self.top.data
        self.size -= 1
        if self.top.next:
            self.top = self.top.next
        else:
            self.top = None
        return data
    else:
        return None
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							The thing to pay attention to here is the inner <b>if</b> statement. If the top node has its next attribute pointing to another node, then we must set the top of the stack to now point to that node:
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/Node3.png" alt="Node3">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							When there is only one node in the stack, the pop operation will proceed as follows:
						</p>
						<img src="../Assets/Node4.png" alt="Node4">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Removing such a node results in self.top pointing to None:
						</p>
						<img src="../Assets/Node5.png" alt="Node5">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Peek</h3>
						<p>
							Returns the top of the stack without removing it from the stack, allowing us to look at the top element without changing the stack itself. 
							If there is a top element, return its data, otherwise return None (so that the behavior of peek matches that of pop):
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code data-trim data-noescape>
def peek(self):
    if self.top:
        return self.top.data
    else:
        return None
</code>
						</pre>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Queues</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>A special type of list is the queue data structure</p>
						<ul>
							<p>When people are standing in a queue waiting for their turn to be served, service is only rendered at the front of the queue.</p>

							<p>To exit the queue they wait until they are served, which only occurs at the very front of the queue.</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>The acronym FIFO best explains this.</p>

						<p>FIFO stands for first in, first out.</p>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/60819122-a1828d80-a164-11e9-9ea0-14e59a50ab83.png" alt="Queue">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Visualizing a Queue is easiest if you think of waiting in line at the bank with a “head” and “tail” on the line. 
						</p>
						<ul>
							<p>You enter the queue by entering the “tail” of the line (also known as <b>shift</b>)</p>
							<p>Once you reach the end/head then you can exit (also known as <b>unshift</b>)</p>
							<p>A Queue is therefore similar to a DoubleLinkedList because you are working from both ends of the data structure.</p>
						</ul>
					</section>
					
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>FIFO Queue</h3>
						<ul>
							<p>rear - Where additions are made to the queue</p>
							<p>front - Where removal is made to the queue</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Queues have two fundamental operations:
						</p>
						<ul>
							<p>enqueue - adds to the rear</p>
							<p>dequeue - removes from the front</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Additional operation:
						</p>
						<ul>
							<p>peek - see the item at the front of the queue</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Real world application of Queue</h3>
						<p>Priority Queue / Dijkstra's shortest path algorithm used in networking routing calculations.


							If two elements have the same rating then they are scheduled in FIFO order.
							
							Elements are ranked from largest to smallest according to some attribute.  
							
							Generally the smallest are removed first no matter when they are added to the queue.
							</p>
.
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6D_Stack_and_Queue_Exercises.html">Lab 6D - Stacks and Queues</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Trees</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Non linear data structures</p>
						<ul>
						<p>Faster than linear data structures.</p>
						<p>Example: 
							<ul>
								<p>File systems</p>
								<p>Graphical user interfaces</p>
								<p>Databases</p>
								<p>Web sites .</p>
							</ul>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<ul>
					<p>Terminology for tree data structures comes from family trees</p>
					</ul>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/Tree1.png" alt="Tree1">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Basic Tree Properties</h3>
						<ul>
							<p>A tree is an abstract data type that stores elements hierarchically </p>
							<p>The top element of the tree is the root</p>
							<p> Other elements are connected below (The opposite of a botanical tree).</p>		
							</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Basic Tree Properties(cont.)</h3>
						<ul>
						<p>Each element in a tree, besides root, has a parent element and zero or more children elements. </p>
						<p>A tree is usually visualized by placing elements inside ovals or rectangles, and drawing connections between parents and children with straight lines. </p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 22px;">A tree with 17 nodes</p>
						<img src="../Assets/Tree2.png" alt="Tree2">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li>Root: Electronics R'Us.</li> 
							<li>Children of root: R & D, Sales, Purchasing, and Manufacturing. </li>
							<li>Internal nodes: Sales, International, Overseas, Electronics R'Us, and Manufacturing.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Formal Tree Definition</h4>
						<ul>
							<li>Set of nodes that have a parent-child relationship</li>
							<li>A nonempty tree has a special node called the root that has no parent.</li>
							<li>Each node of the tree that is not the root has a unique parent node
							<li>Every node with parent is a child</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b><i>Note</i></b>: According to our definition a tree can be empty</p>
					    <p>This allows us to define a tree recursively such that a tree is either empty or has a root, 
							and a (possibly empty) set of subtrees whose roots are the children of root.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Tree Definitions</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p><b>Node</b>: An item stored in a tree</p>

							<p><b>Root</b>: The topmost node in a tree. It is the only node without a parent</p>

							<p><b>Child</b>: 
								<ul>
									<li>A node immediately below and directly connected to a given node.</li> 
									<li>A node can have more than one child</li>
									<li>Children are viewed as organized in left-to-right order.</li> 
									<li>The leftmost child is called the first child</li> 
									<li>The rightmost child is the last child.</li>	
								</ul>
							</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p><b>Parent</b>: A node immediately above and directly connected to a given node. A node: can only have one parent.</p>

							<p><b>Siblings</b>: The children of a common parent</p>

							<p><b>Leaf</b>: A node that has no children</p>

							<p><b>Interior Node</b>: A node that has at least one child</p>

					    	<p><b>Edge/Branch/Link</b>: The line that connects a parent to its child</p>
						</ul>
					</section>
				
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
						<p><b>Descendant</b>: A node's children, its children's children, and so on, down to the leaves</p>

						<p><b>Ancestor</b>: A node's parent, its parent's parent, and so on, up to the root</p>
							
						<p><b>Path</b>: The sequence of edges that connect a node and one of its descendants</p>
							
						<p><b>Path length</b>: The number of edges in a path</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							
							<p><b>Depth or level</b>: The depth or level of a node equals the length of the path connecting it to the root. Thus, the root depth or level of the root is 0. Its children are at level 1, and so on.</p>
							
							<p><b>Height</b>: The length of the longest path in the tree; put differently, the maximum level number among leaves in the tree</p>
							
							<p><b>Subtree</b>: The tree formed by considering a node and all its descendants</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/Tree_properties.png" alt="Tree Properties">
						
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Tree Use Examples</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Tree Representation of a File System Example</p>
						<img src="../Assets/Tree3.png" alt="Tree3">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Computer File System </h3>
						<ul>
							<p>
								The internal nodes of the tree are associated with directories and the leaves are associated with regular files.</p>
							<p>In the UNIX and Linux operating systems, 
								the root of the tree is called the “root directory” and is represented by the symbol “/.”
							</p>
						</ul>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Tree Representation of the Python Exception Classes</p>
						<img src="../Assets/Tree4.png" alt="Tree4">			
					</section>
					
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Inheritance between classes in a Python program forms a tree when single inheritance is used.</p>
						<p>The BaseException class is the root.  All user-defined exception classes should conventionally
							 be declared as descendants of the more specific Exception class.</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Types of Trees</h3>
                        <h2>General vs Binary</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>General Tree</b></p>
						<ul>
							<li>Each node can have either zero or any number of child nodes.</li>
							<li>Can be many subtrees in a general tree</li>
							<li>Unordered - nodes can not be ordered by any specific criteria.</li> 
							<li>Cannot be empty.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Binary Tree</b></p>
						<ul>
							<li>Parent node can have a maximum of 2 child nodes lLeft child and right child).</li>
							<li>Two subtrees (right and left).</li> 
							<li>Nodes can be ordered because of specific criteria. </li>
							<li>Can be empty.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">General vs Binary</p>
						<img src="../Assets/general_vs_binary.png" alt="General vs Binary">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Binary Tree Types</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Perfectly Balanced Binary Tree</b>: Includes a complete complement of nodes at each level but the last one.
						<p>Complete and Full binary are special cases of perfectly balanced</p>			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Full Binary Tree</b>: Referred to as a proper or plane binary tree</p>
						<p>Every node, except the leaves, has 2 children</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Full Binary Tree</p>
						
						<img src="../Assets/full_binary_trees.png" alt="Full Binary">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Complete Binary Tree</b>: Every level, except possibly the last, is completely filled and all nodes in the last level are as far left as possible</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Complete Binary Tree</p>
						
						<img src="../Assets/complete_binary_trees.png" alt="Complete Binary">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Balanced Binary Tree</b>: The left and right subtrees of every node differ in height by no more than 1.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Balanced Binary Tree</p>
						
						<img src="../Assets/balanced_binary_trees.png" alt="Balanced Binary">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Perfect Binary Tree</b>: All internal nodes have two children and all leaf nodes are at the same level. A perfect binary tree of height h has 2^h - 1 nodes.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Perfect Binary Tree</p>
						
						<img src="../Assets/perfect_binary_trees.png" alt="Perfect Binary">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Degenerate Binary Tree</b>: Also called an unbalanced or pathological binary tree. Every internal node has one child.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Degenerate Binary Tree</p>
						<img src="../Assets/degenerate_binary_trees.png" alt="Degenerate Binary">			
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Building Trees</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>The process of assembling a tree is similar to the process of assembling a linked list. Each constructor invocation builds a single node.</p>
					</section>
				
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code data-trim data-noescape>
    class Tree:
        def _init_(self, data, left=None, right=None):
            self.data = data
            self.left = left
            self.right = right
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Recursive Traversing Function</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>The most natural way to traverse a tree is recursively.</p>
						<p>The following code shows a function named total that returns the sum of all the nodes by using recursion</p>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code data-trim data-noescape>
def total(tree):
    if tree == None: 
        return 0
    return total(tree.left) + total(tree.right) + tree.data
</code>
                        </pre>
                        <ul>
							<p>The base case is the empty tree, which contains no data, so the total is 0.</p>
							<p>The recursive step makes two recursive calls to find the total of the child trees.</p>
							<p>When the recursive calls complete, we add the data of the parent and return the total.</p>
								
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>
							Tree Traversal
						</h3>
					</section>	
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>There are different of ways to traverse a tree.</p>
								
							<p><b>Depth first</b></p> 
							<ul>
								<p><i>Pre Order</i></p>
								<p><i>Post Order</i></p>
								<p><i>In Order</i></p>
							</ul>
							<p><b>Breadth first</b></p>
							<ul>
								<p><i>Level Order</i></p>
							</ul>
								
						</ul>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Depth First Traversal</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Pre Order</b>:  <i>(root -> left -> right )</i></p>
						<ul>
							<li>Check if the current node is empty, if not empty continue</li>
							<li>Display the data part of the root or current node</li>
							<li>Traverse the left subtree by recursively calling preorder</li>
							<li>Traverse the right subtree by recursively calling preorder</li>
						</ul>

					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Pre Order Traversal</p>
						<img src="../Assets/Preorder_Traversal.png" alt="Pre Order">			
					</section>
				
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Post Order</b>:  <i>( left -> right -> root )</i></p>
						<ul>
							<li>Check if the root node is empty, if not empty continue</li>
							<li>Traverse the left subtree by recursively calling postorder</li>
							<li>Traverse the right subtree by recursively calling postorder</li>
							<li>Display the root</li>
						</ul>

					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">Post Order Traversal</p>
						<img src="../Assets/Postorder_Traversal.png" alt="Post Order">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>In Order</b>:  <i> ( left -> root -> right )</i></p>
						<ul>
							<li>Check if the root node is empty, if not empty continue</li>
							<li>Traverse the left subtree by recursively calling inorder</li>
							<li>Display the root</li>
							<li>Traverse the right subtree by recursively calling inorder</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 20px;">In Order Traversal</p>
						<img src="../Assets/Inorder_Traversal.png" alt="In Order">			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Breadth First Traversals</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Level Order</b>: Visits each node at each level in left-to-right order</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Expression Trees</h3>
						<p>Represent the structure of a mathematical expression</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Expression tree explanation</p>
						<ul>
						<li>Operands are leaf nodes.</li>
						<li>Operator nodes contain references to their operands.</li>
						<li>All of the operators are binary (exactly two operands)</li>	
					</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p>Expression trees can represent computations unambiguously</p>
							<p>For example, the infix expression 1 + 2 * 3 is ambiguous unless we know that the multiplication happens before the addition. 
							<p>To do this we use different notations to represent how to proceed.</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Expression Tree Notation</h3>
						<p>Notations are used for describing how to write expressions.</p>
						<ul>
							<li>Infix</li>
							<li>Postfix</li>
							<li>Prefix</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><i><b>Infix</b></i>: Operators are written in between operands</p>
						<p><b>X + Y</b></p>
						<p><i><b>Postfix</b></i>: Operators are written after their operands </p>
						<p><b>X Y + </b></p>
						<p><i><b>Prefix</b></i>: Operators are written before their operands</p>
						<p><b>+ X Y </b></p>	
					</section>	
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Expression Tree Traversal Examples</h3>
							<p><i><b>tree = Tree('+', Tree(1), Tree('*', Tree(2), Tree(3)))</b></i></p>
							<ul>
								<ul>
									<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</p>
									<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
									<p style="font-size: 24px;">1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*</p>
									<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
									<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3</p>
								</ul>
							</ul>					
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> Pre Order Traversal</b></p>	
                        <pre>
<code data-trim data-noescape>
#tree = Tree('+', Tree(1), Tree('*', Tree(2), Tree(3)))
def print_tree_preorder(tree):
    #data -> left -> right
    if tree == None: 
        return 0
    print(tree.data)
    print_tree_preorder(tree.left)
    print_tree_preorder(tree.right)
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> Pre Fix  Output</b></p>	
<code>
print_tree_inorder(tree)
1 + 2 * 3
</code>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> Post Order Traversal</b></p>	
						<pre>
<code data-trim data-noescape>
#tree = Tree('+', Tree(1), Tree('*', Tree(2), Tree(3)))
def print_tree_postorder(tree):
    #left -> right -> data
    if tree == None: 
        return 0
    print(tree.data)
    print_tree_postorder(tree.left)
    print_tree_postorder(tree.right)
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> Post Fix  Output</b></p>	
<code>
print_tree_inorder(tree)
1 + 2 * 3
</code>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> In Order Traversal</b></p>	
						<pre>
<code data-trim data-noescape>
#tree = Tree('+', Tree(1), Tree('*', Tree(2), Tree(3)))
def print_tree_inorder(tree):
    #left -> data -> right
    if tree == None: 
        return 0
    print(tree.data)
    print_tree_inorder(tree.left)
    print_tree_inorder(tree.right)
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> InFix  Output</b></p>
                        <pre>
<code>
print_tree_inorder(tree)
1 + 2 * 3
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>In Order Traversal to print indented tree representation</b></p>
                        <pre>
<code data-trim data-noescape>
#tree = Tree('+', Tree(1), Tree('*', Tree(2), Tree(3)))
def print_tree_indented(tree, level=0):
    if tree == None: 
        return 0
    print_tree_indented(tree.right, level + 1)
    print '  ' * level + str(tree.data)
    print_tree_indented(tree.left, level + 1)
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b> In Order Indented Tree Representation Output</b></p>	
						<ul>
							<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3</p>
							<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*</p>
							<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2</p>
							<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;+</p>
							<p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1</p>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Binary Search Tree</h2>	
						<h3>BST</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">	
						<p>A Binary Search tree is a special binary tree where:</p>
						<ul>
							<li>The left child of a node has a value less than the parent.</li>
							<li>The right child has a value greater than the parent.</li>
						</ul>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>Binary Search Tree Operations</h3>	
                        <ul>
                            <p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3</p>
                            <p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/</p>
                            <p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2</p>
                            <p style="font-size: 24px;">&nbsp;&nbsp;&nbsp;/</p>
                            <p style="font-size: 24px;">1</p>
                        </ul>
                            

					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h3>Binary Search Tree Operations</h3>
                        <p style="font-size: 22px;"><b>Searching</b>: Searching for element 1 - Traverse all elements (in order 3, 2, 1).
                        </p>
                        <p style="font-size: 22px;">Worst case complexity of O(n).
                            In general, time complexity is O(h) where h is height of BST</p>	
						<p style="font-size: 22px;"><b>Insertion</b>: Inserting element 0 - Must be inserted as left child of 1.
							Traverse all elements (in order 3, 2, 1).</p>
						<p style="font-size: 22px;"> Worst case complexity
							of O(n). In general, time complexity is O(h).</p>
                        <p style="font-size: 22px;"><b>Deletion</b>: Deletion of element 1 - Traverse all elements
                            to find 1 (in order 3, 2, 1).</p>
                        <p style="font-size: 22px;"> Deletion in binary tree has worst case complexity of O(n). In general, time complexity is O(h).</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						
						<p>Three Cases for Deletion From Binary tree:</p>
						<ul>
							<li>Node to be deleted is a leaf node (No child). Directly delete the node from the tree.</li>
							<li>Node to be deleted is an internal node with one child. Copy the child to the node then delete the child</li>
							<li>Node to be deleted is an internal node with two children Two methods: 
								<ul>
									<li>Find the minimum of the right side, copy and delete</li>
									<li>Find the maximum of the left side, copy and delete</li>
								</ul>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Completely sorted Binary Search Tree - AVL</h3>
						<p>AVL = Named after Gregory Adelson-Velsky and Evgenii Landis</p>
						<ul>
							<p style="font-size: 22px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</p>
							<p style="font-size: 22px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 22px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</p>
							<p style="font-size: 22px;">&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 22px;">1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</p>
						</ul>			
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						
						<ul>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</p>
						</ul>
						<p style="font-size: 22px;"><b>Searching</b>: Searching for element 1 - Traverse elements (in order 5, 4, 1) = 3 = log n. </p>
						<p style="font-size: 22px;"> Worst case complexity of O(log n)</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						
						<ul>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</p>
						</ul>
						<p style="font-size: 22px;"><b>Insertion</b>:Inserting element 12 - Traverse elements elements (in order 5, 7, 9)</p>
						<p style="font-size: 22px;"> Worst case complexity of O(log n)</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						
						<ul>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</p>
							<p style="font-size: 15px;">&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\</p>
							<p style="font-size: 15px;">1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</p>
						</ul>
						<p style="font-size: 22px;"><b>Deletion</b>:Deleting element 9 - Traverse elements to find 9 (in order 5, 7, 9)</p>
						<p style="font-size: 22px;"> Worst case complexity of O(log n)</p>
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Trees_Perf_Labs.html">Lab 6E - Trees</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>TRIE</h2>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Trie Info</h3>
						<ul>
							<li>Comes from the word re<b>trie</b>val</li>
							<li>Also known as digital trees and prefix trees,</li>
							<li>Used in information retrieval by storing strings to support fast pattern and prefix matching.</li>
							<li>The maximum number of children that any node can have is equal to the number of symbols in the alphabet.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Trie Node Class</h2>
                        <pre>
<code>
class TrieNode:
    def __init__(self):
        self.children = [None]*26
        self.endword = False
</code>
                        </pre>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Trie Class</h2>	
                        <pre>
<code>
class Trie:
    def __init__(self):
        self.root = TrieNode()
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Trie Example</h3>	
						<img src="../Assets/trie_example.png" alt="Trie Example">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Insert the word <b>TOP</b> into an empty trie</h2>	
						<img src="../Assets/insert_trie.png" alt="Insert Trie">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Trie with word Top</h2>	
						<img src="../Assets/top_trie.png" alt="Top Trie">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Search for a word in a trie</h2>	
						<ul>
							<li>Traverse the trie through each node corresponding with the letters in the word that's being searched</li>
							<li>Check the endword attribute at the final node in the path.</li> 
								<ul>
									<li>If the endword attribute is True then the word is in the trie</li>
									<li>If it is False then the word is not in the trie.</li>
								</ul>  
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Removal Scenarios</h2>	
						<img src="../Assets/removal_trie.png" alt="Removal Trie">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete a word that is a prefix to another word - <b>APE</b></h3>	
						<ul>
							<li>Traverse the path <b>A-P-E</b></li>
							<li>Set the <b>E</b> node's endword attribute to False</li>
							<li>Check if the <b>E</b> node has any children</li>
							<li>There are children of the <b>E</b> node, we can stop</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete <b>APE</b> result</h3>
						<img src="../Assets/delete_word_is_prefix_trie.png" alt="Delete word that is a prefix">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete a word that has no children - <b>APES</b></h3>	
						<ul>
							<li>Traverse the path <b>A-P-E-S</b></li>
							<li>Set the <b>S</b> node's endword attribute to False</li>
							<li>Check if the <b>S</b> node has any children</li>
							<li>There are no children, the <b>S</b> node has no reason to exist in the trie, and therefore should be deleted.</li>
							<li>Go up to the <b>E</b> node and remove the reference to the <b>S</b> node by setting the index in the children attribute for <b>S</b> to None</li>
							<li>Since the <b>E</b> node's endword attribute is True, we can stop</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete <b>APES</b> result</h3>
						<img src="../Assets/delete_no_children_trie.png" alt="Delete word with no children">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete a word that part of the word is a prefix - <b>APPLE</b></h3>	
						<ul>
							<li>Traverse the path <b>A-P-P-L-E</b></li>
							<li>Check if the <b>E</b> node has any children</li>
							<li>Move up to the <b>L</b> node and remove the reference to the <b>E</b> node</li>
							<li>There are more nodes to be checked to make sure the word is removed properly</li>
							<li>Move up to the <b>P</b> node and remove the reference to the <b>L</b> node</li>
							<li>Repeat the process until a node's endword attribute is True <b>OR</b> the node has children</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Delete "APPLE" result</h3>
						<img src="../Assets/delete_part_word_prefix_trie.png" alt="Delete word with part is prefix">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Big O</h3>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Inserting, searching, and deleting a single word</p>
						<p><b>O(n)</b></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Creating a trie</h3>
						<ul>
						<p>How many words are in the trie <b>(n)</b></p>
						<p>The average length of the words <b>(m)</b></p>
						<p><b>O(n*m)</b></p>
						</ul>
					</section>
				</section>
                <section>
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Summary</h2>
                        <ul>
                            <li><b>List Pointer Structures</b></li>
                            <li><b>Linked Lists</b></li>
                            <li><b>Stacks</b></li>
                            <li><b>Queues</b></li>
                            <li><b>Trees</b></li>
                        </ul>
                    </section>
                </section>
                
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
j